Index: branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.Designer.cs
===================================================================
--- branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.Designer.cs	(revision 7404)
+++ branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.Designer.cs	(revision 7468)
@@ -45,5 +45,5 @@
     /// </summary>
     private void InitializeComponent() {
-      this.btnImport = new System.Windows.Forms.Button();
+      this.importButton = new System.Windows.Forms.Button();
       this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
@@ -60,5 +60,5 @@
       // splitContainer.Panel2
       // 
-      this.splitContainer.Panel2.Controls.Add(this.btnImport);
+      this.splitContainer.Panel2.Controls.Add(this.importButton);
       // 
       // itemsGroupBox
@@ -76,11 +76,11 @@
       // btnImport
       // 
-      this.btnImport.Location = new System.Drawing.Point(3, 4);
-      this.btnImport.Name = "btnImport";
-      this.btnImport.Size = new System.Drawing.Size(75, 23);
-      this.btnImport.TabIndex = 7;
-      this.btnImport.Text = "Import";
-      this.btnImport.UseVisualStyleBackColor = true;
-      this.btnImport.Click += new System.EventHandler(this.btnImport_Click);
+      this.importButton.Location = new System.Drawing.Point(3, 4);
+      this.importButton.Name = "btnImport";
+      this.importButton.Size = new System.Drawing.Size(75, 23);
+      this.importButton.TabIndex = 7;
+      this.importButton.Text = "Import";
+      this.importButton.UseVisualStyleBackColor = true;
+      this.importButton.Click += new System.EventHandler(this.importButton_Click);
       // 
       // openFileDialog
@@ -106,5 +106,5 @@
     #endregion
 
-    private System.Windows.Forms.Button btnImport;
+    private System.Windows.Forms.Button importButton;
     private System.Windows.Forms.OpenFileDialog openFileDialog;
   }
Index: branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs
===================================================================
--- branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs	(revision 7404)
+++ branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs	(revision 7468)
@@ -45,5 +45,5 @@
     protected override void SetEnabledStateOfControls() {
       base.SetEnabledStateOfControls();
-      btnImport.Enabled = !Locked && !ReadOnly && Content != null;
+      importButton.Enabled = !Locked && !ReadOnly && Content != null;
     }
 
@@ -62,49 +62,49 @@
     #endregion
 
-    private void btnImport_Click(object sender, System.EventArgs e) {
-      if (openFileDialog.ShowDialog(this) == DialogResult.OK) {
-        object hlFile = null;
-        try {
-          hlFile = XmlParser.Deserialize(openFileDialog.FileName);
-        }
-        catch (Exception ex) {
-          ErrorHandling.ShowErrorDialog(this, ex);
-        }
+    private void importButton_Click(object sender, EventArgs e) {
+      if (openFileDialog.ShowDialog(this) != DialogResult.OK) return;
 
-        if (hlFile != null) {
-          IRegressionProblemData problemData = null;
-          if (hlFile is RegressionProblemData) {
-            problemData = (RegressionProblemData)hlFile;
-          } else if (hlFile is IRegressionProblem) {
-            problemData = ((IRegressionProblem)hlFile).ProblemData;
-          } else if (hlFile is IRegressionSolution) {
-            problemData = ((IRegressionSolution)hlFile).ProblemData;
-          }
+      object hlFile = null;
+      try {
+        hlFile = XmlParser.Deserialize(openFileDialog.FileName);
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog(this, ex);
+        return;
+      }
 
-          if (problemData == null) {
-            ErrorHandling.ShowErrorDialog(this,
-              new NullReferenceException("The problem data is null." + Environment.NewLine
-                                       + "The .hl-file is no RegressionProblemData or RegressionProblem."));
-          } else {
-            StringBuilder message = new StringBuilder();
-            if (!problemData.TargetVariable.Equals(Content.ProblemData.TargetVariable))
-              message.AppendLine("The target variables are not matching. Old target variable: '"
-                               + Content.ProblemData.TargetVariable
-                               + "'. New targetvariable: '" + problemData.TargetVariable + "'");
+      IRegressionProblemData problemData = null;
+      if (hlFile is IRegressionProblemData) {
+        problemData = (IRegressionProblemData)hlFile;
+      } else if (hlFile is IRegressionProblem) {
+        problemData = ((IRegressionProblem)hlFile).ProblemData;
+      } else if (hlFile is IRegressionSolution) {
+        problemData = ((IRegressionSolution)hlFile).ProblemData;
+      }
 
-            List<string> variables = problemData.InputVariables.Select(x => x.Value).ToList();
+      if (problemData == null) {
+        ErrorHandling.ShowErrorDialog(this,
+          new NullReferenceException("The problem data is null." + Environment.NewLine
+                                   + "The .hl-file is no RegressionProblemData or RegressionProblem."));
+        return;
+      }
 
-            foreach (var item in Content.ProblemData.InputVariables.CheckedItems) {
-              if (!variables.Contains(item.Value.Value))
-                message.AppendLine("Input variable '" + item.Value.Value + "' is not in the new problem data.");
-            }
+      StringBuilder message = new StringBuilder();
+      if (!problemData.TargetVariable.Equals(Content.ProblemData.TargetVariable))
+        message.AppendLine("The target variables are not matching. Old target variable: '"
+                         + Content.ProblemData.TargetVariable
+                         + "'. New targetvariable: '" + problemData.TargetVariable + "'");
 
-            if (message.Length != 0)
-              ErrorHandling.ShowErrorDialog(this, new Exception(message.ToString()));
-            else
-              Content.ProblemData = problemData;
-          }
-        }
+      List<string> variables = problemData.InputVariables.Select(x => x.Value).ToList();
+      foreach (var item in Content.ProblemData.InputVariables.CheckedItems) {
+        if (!variables.Contains(item.Value.Value))
+          message.AppendLine("Input variable '" + item.Value.Value + "' is not in the new problem data.");
       }
+
+      if (message.Length != 0)
+        ErrorHandling.ShowErrorDialog(this, new Exception(message.ToString()));
+      else
+        Content.ProblemData = problemData;
+
     }
   }